<?php
/* not marked code-segments (c) 2006, Peter Kahoun aka Kahi
       marked code-segments (c) 2006, Other people
 * Uploader, version 1.2, last change 14.8.2006
 * web: uploader.kahi.cz
 * mail:    kahi@kahi.cz

 * BSD licence, see licence.txt for additional information
*/

Header("Content-Type: text/html; charset=utf-8");

require('upl_config.php');
require('upl_func.php');
require('upl_lang_'.LANGUAGE.'.php');
$timer = new Timer;
$timer->start();

handle_login();
handle_logout();
define_logged();

if(!LOGGED AND NEED_PASSWORD) {
  echo_login_form();
  exit;
}

// Upload-dir check
if(!is_dir(DIR.'/'.UPL_DIR)) {
 Err('err_upldir_ex');
} elseif(!is_writable(DIR.'/'.UPL_DIR)) {
 Err('err_upldir_w');
}

put_dir_creation();
put_sort_changing();
handle_upload();
handle_delete();

check_free_space();

$sort_par = prepare_sorting();

// playing with dir list
get_dir_list();
if(count($dir_list)) {
	sort($dir_list);
	$html_dir_list = html_dir_list($dir_list); // select menu
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $lang['main']['content_language']; ?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Language" content="<?php echo $lang['main']['content_language']; ?>" />
		<title><?php echo $lang['main']['title']; ?></title>
	<meta name="robots" content="noindex, nofollow" />
	<meta name="googlebot" content="noindex, nofollow, nosnippet, noarchive" />
	<meta name="generator" content="Uploader v 1.2, web: uploader.kahi.cz" />
	<link rel="stylesheet" type="text/css" media="screen, projection" href="<?php echo $design['css_file']; ?>" />
<script type="text/javascript">
	field=new Array;
	function DoIt(id) {
		/* if it's closed, then open */
		if(field[id] == 'closed') {
			/* it's not ie */
			if('Microsoft Internet Explorer' != navigator.appName) {
				document.getElementById(id).style.display = 'table-row-group';
			/* it's ie */
			} else {
				document.getElementById(id).style.display = 'inline';
			}
			field[id] = 'open';
		/* if it's opened, then close */
		} else {
			document.getElementById(id).style.display = 'none';
			field[id] = 'closed';
		}
	}

	function deleteDialog(file) {
		var message;
		message = '<?php echo $lang['else']['deleteDialog_question']; ?>' + file + ' ?';
		if ( confirm(message) ) {
			return true;
		} else {
			return false;
		}
	}
</script>


</head>

<body>
<? if(NEED_PASSWORD) { // when you're here, you must be logged ?>
	<div id="logout"><a href="?do=logout"><span><?php echo $lang['main']['logout_text']; ?></span></a></div>
<? } ?>
<div id="main">
<div id="mainI">

<h1><span><?php echo $lang['main']['heading']; ?></span></h1>

<div id="afterH1">&nbsp;</div>

<div id="upload">
<div id="uploadI">
	<h2><?php echo $lang['main']['heading_upload']; ?></h2>
	<form action="?do=upl" method="post" enctype="multipart/form-data">
		<div><input name="userfile" type="file" />
		<?php echo $html_dir_list; ?>
		<input type="submit" value="<?php echo $lang['main']['button_upload']; ?>"<?php if(!CAN_UPLOAD) echo ' disabled="disabled"'; ?> /></div>
		<?php echo $lang['main']['upload_note']; ?>
	</form>
</div>
</div>

<div id="afterUpload">&nbsp;</div>

<div id="newDir">
<div id="newDirI">
	<h2><?php echo $lang['main']['heading_new_dir']; ?></h2>
	<form action="?do=new_dir" method="post">
		<div>
		<input type="text" name="dir_name" title="<?php echo $lang['else']['input_new_dir_title']; ?>" />
		<?php echo str_replace(' selected="selected"', '',$html_dir_list); ?>
		<input type="submit" value="<?php echo $lang['main']['button_new_dir']; ?>" />
		<?php echo $lang['main']['new_dir_note']; ?></div>
	</form>
</div>
</div>

<div id="afterNewDir">&nbsp;</div>

<div id="beforeFileList">&nbsp;</div>

<div id="fileList">
<div id="fileListI">
	<h2><?php echo $lang['main']['heading_files']; ?></h2>
	<?php echo_messages(); ?>
	<?php whole_file_list(); ?>
</div>
</div>


<div id="afterFileList">&nbsp;</div>

<div id="stats">
	<h2><?php echo $lang['main']['heading_stats']; ?></h2>
	<p><strong><?php echo $lang['main']['stats_size']; ?>:</strong> <?php echo_size_of_all(); 
		if(MAX_SPACE > 0) {
			echo ' / '. $max_space;
			echo ' <span id="free_space">('. $free_space .' '. $lang['else']['stats_left'] .')</span>';
		}
		?></p>
	<p><strong><?php echo $lang['main']['stats_count']; ?>:</strong> <?php echo $file_count_all; ?></p>
</div>

</div>
</div>
</body>
</html><!--	<?php $timer->stop(); echo $timer->returntime(); ?> -->
<?php
$_SESSION['msg'] = NULL;
$_SESSION['upl'] = NULL;
?>
