<?php
/* not marked code-segments (c) 2006, Peter Kahoun aka Kahi
			 marked code-segments (c) 2006, Other people
 * Uploader, version 1.2, last change 14.8.2006
 * web: uploader.kahi.cz
 * mail:		kahi@kahi.cz

 * BSD licence, see licence.txt for additional information
*/
session_start();
define('DIR', getcwd());
define('NL', "\n");
define('BR', '<br />');

//						\\

function Home ()
{
	Header('Location: ?');
	exit;
}

//						\\

function put_sort_changing ()
{
	if(isset($_GET['do']) AND $_GET['do'] == 'sort' AND isset($_GET['val'])) {
		setcookie('upl_sort', $_GET['val'], time()+30*24*3600);
		Home();
	}
}

//						\\

function Msg ($string)
{
	$_SESSION['msg'] = $string;
}

//						\\

function Err ($err)
{
	global $lang;
	echo '<div style="color:red;">'. $lang['msg'][$err] .'</div>';
	exit;
}

//						\\

function format_file_size ($bytes)
{
	if($bytes >= 1048576) {
		 $return = round($bytes / 1024 / 1024, 1);
		 $suffix = ' MB';
	} elseif ($bytes >= 1024) {
		 $return = round($bytes / 1024, 0);
		 $suffix = ' <span>KB</span>';
	} else {
		 $return = '<span>0 KB</span>';
		 $suffix = '';
	}
	$return .= $suffix;

	return $return;
}

//						\\

function secure_the_dirname ($name)
{
	$in	= Array('À','Á','Â','Ã','Ä','Å','Ā','Ă','Ç','Ć','Ĉ','Ċ','Č','Ď','Đ','È','É','Ê','Ë','Ē','Ĕ','Ė','Ę','Ě','Ĝ','Ğ','Ġ','Ģ','Ĥ','Ì','Í','Î','Ï','Ĩ','Ī','Ĭ','Į','İ','Ĵ','Ķ','Ĺ','Ļ','Ľ','Ŀ','Ł','Ñ','Ń','Ņ','Ň','Ŋ','Ò','Ó','Ô','Õ','Ö','Ō','Ŏ','Ő','Ŕ','Ŗ','Ř','Ś','Ŝ','Ş','Š','Ţ','Ť','Ù','Ú','Û','Ü','Ũ','Ū','Ŭ','Ů','Ű','Ų','Ŵ','Ý','Ŷ','Ÿ','Ź','Ż','Ž','à','á','â','ã','ä','å','ā','ă','ą','ç','ć','ĉ','ċ','č','ď','đ','è','é','ê','ë','ē','ĕ','ė','ę','ě','ĝ','ğ','ġ','ģ','ĥ','ħ','ì','í','î','ï','ĩ','ī','ĭ','į','ı','ĵ','ķ','ĺ','ļ','ľ','ŀ','ł','ñ','ń','ņ','ň','ŉ','ŋ','ò','ó','ô','õ','ö','ō','ŏ','ő','ŕ','ŗ','ř','ś','ŝ','ş','š','ţ','ť','ù','ú','û','ü','ũ','ū','ŭ','ů','ű','ų','ŵ','ý','ÿ','ŷ','ź','ż','ž');
	$out = Array('A','A','A','A','A','A','A','A','C','C','C','C','C','D','D','E','E','E','E','E','E','E','E','E','G','G','G','G','H','I','I','I','I','I','I','I','I','I','J','K','L','L','L','L','L','N','N','N','N','N','O','O','O','O','O','O','O','O','R','R','R','S','S','S','S','T','T','U','U','U','U','U','U','U','U','U','U','W','Y','Y','Y','Z','Z','Z','a','a','a','a','a','a','a','a','a','c','c','c','c','c','d','d','e','e','e','e','e','e','e','e','e','g','g','g','g','h','h','i','i','i','i','i','i','i','i','i','j','k','l','l','l','l','l','n','n','n','n','n','n','o','o','o','o','o','o','o','o','r','r','r','s','s','s','s','t','t','u','u','u','u','u','u','u','u','u','u','w','y','y','y','z','z','z');
	$name = str_replace($in,$out,$name);

	$name = StrToLower($name);

	$name = ereg_replace('[^a-z 0-9_-]', '', $name); // delete unwanted
	$name = ereg_replace(' +', '-', $name); // spaces => -
	$name = trim($name, '-_');

	return $name;
}

//						\\

function secure_the_filename ($name, $maxlen)
{
	$name = StrToLower($name);

	$in	= Array('À','Á','Â','Ã','Ä','Å','Ā','Ă','Ç','Ć','Ĉ','Ċ','Č','Ď','Đ','È','É','Ê','Ë','Ē','Ĕ','Ė','Ę','Ě','Ĝ','Ğ','Ġ','Ģ','Ĥ','Ì','Í','Î','Ï','Ĩ','Ī','Ĭ','Į','İ','Ĵ','Ķ','Ĺ','Ļ','Ľ','Ŀ','Ł','Ñ','Ń','Ņ','Ň','Ŋ','Ò','Ó','Ô','Õ','Ö','Ō','Ŏ','Ő','Ŕ','Ŗ','Ř','Ś','Ŝ','Ş','Š','Ţ','Ť','Ù','Ú','Û','Ü','Ũ','Ū','Ŭ','Ů','Ű','Ų','Ŵ','Ý','Ŷ','Ÿ','Ź','Ż','Ž','à','á','â','ã','ä','å','ā','ă','ą','ç','ć','ĉ','ċ','č','ď','đ','è','é','ê','ë','ē','ĕ','ė','ę','ě','ĝ','ğ','ġ','ģ','ĥ','ħ','ì','í','î','ï','ĩ','ī','ĭ','į','ı','ĵ','ķ','ĺ','ļ','ľ','ŀ','ł','ñ','ń','ņ','ň','ŉ','ŋ','ò','ó','ô','õ','ö','ō','ŏ','ő','ŕ','ŗ','ř','ś','ŝ','ş','š','ţ','ť','ù','ú','û','ü','ũ','ū','ŭ','ů','ű','ų','ŵ','ý','ÿ','ŷ','ź','ż','ž');
	$out = Array('A','A','A','A','A','A','A','A','C','C','C','C','C','D','D','E','E','E','E','E','E','E','E','E','G','G','G','G','H','I','I','I','I','I','I','I','I','I','J','K','L','L','L','L','L','N','N','N','N','N','O','O','O','O','O','O','O','O','R','R','R','S','S','S','S','T','T','U','U','U','U','U','U','U','U','U','U','W','Y','Y','Y','Z','Z','Z','a','a','a','a','a','a','a','a','a','c','c','c','c','c','d','d','e','e','e','e','e','e','e','e','e','g','g','g','g','h','h','i','i','i','i','i','i','i','i','i','j','k','l','l','l','l','l','n','n','n','n','n','n','o','o','o','o','o','o','o','o','r','r','r','s','s','s','s','t','t','u','u','u','u','u','u','u','u','u','u','w','y','y','y','z','z','z');
	$name = str_replace($in,$out,$name);
	$name = StrToLower($name);

	$in =	Array(' ','°','+','=','´','ˇ','€','[',']','{','}','\'','(',')','§','¨',',');
	$out = Array('-','','_','_','', '', '', '_','_','_','_', '',	'_','_','_','', '_');
	$name = str_replace($in,$out,$name);

	if(strlen($name)>$maxlen) {
		$ext = get_ext($name);
		$name = str_replace('.'.$ext, '', $name);
		$name = substr($name, 0, $maxlen-5) . '_.' . $ext;
	}
	return $name;
}

//						\\

function get_ext ($name)
{
	return array_pop(explode('.', $name));
}

//						\\

function is_good_dir($string, $dir) // I want only dirs
{
	if(!in_array($string, array('.', '..'))
	AND ('dir' == filetype(DIR.'/'.UPL_DIR.'/'.$dir.'/'.$string))) {
		return true;
	} else return false;
}

//						\\

function get_dir_list ($dir = '')
{
	global $dir_list;

	$handle = opendir(UPL_DIR.'/'.$dir);
	while (($file = readdir($handle)) !== false) {
		if(is_good_dir($file,$dir)) {
			$dir_list[] = $dir.'/'.$file;
			get_dir_list($dir.'/'.$file);
		}
	}
	closedir($handle);
}

//						\\

function html_dir_list($dir_list)
{
	global $lang;

	$html = '';
	if(count($dir_list)) {
		$html =	'<select name="target_dir" size="1" title="'. $lang['else']['select_dir_title'] .'"> <option value="/">/</option>';
		foreach ($dir_list as $dir) {
			if($dir != '/') $dir = trim($dir, '/'); // removes slash from the beg. of every list-item
			if($dir == $_SESSION['remember_dir']) {
				$selected = ' selected="selected"';
			} else {
				$selected = '';
			}
			$html .= '<option value="'.$dir.'"'.$selected.'>'.$dir.'</option>'.NL;
		}
		$html .= '</select>';
	}

	return $html;
}

//						\\

function put_dir_creation ()
{
	if(isset($_GET['do']) AND $_GET['do'] == 'new_dir' AND $_POST['dir_name'] !== '') {
		$dir_name = secure_the_dirname($_POST['dir_name']);
		$target_dir = $_POST['target_dir'];
		$target_dir = secure_path($target_dir);

		if($target_dir != '/') $target_dir = '/'.$target_dir.'/';

		if(!EregI("^[a-z0-9_-]{1,50}$", $dir_name)) {
			Msg('err_dir_bad_name');
			Home();
		} else {
			if(is_dir(DIR.'/'.UPL_DIR.'/'.$target_dir.$dir_name)) {
				Msg('err_dir_exists');
				Home();
			} else {
				$t = umask(0);
				@$created = mkdir (UPL_DIR.'/'.$target_dir.$dir_name, 0777);
				umask($t);
				if (!$created) {
					Msg('err_dir_not_created');
					Home();
				} else {
					$_SESSION['remember_dir'] = trim($target_dir.$dir_name, '/');
					Msg('ok_dir_created');
					Home();
				}
			}
		}
	}
}

//						\\

function echo_messages ()
{
	global $lang;
	$message = '';

	// special messages
	if (!CAN_UPLOAD) {
		echo '<div class="msg err">'. $lang['msg']['err_no_more_space'] .'</div>';
	}

	// common messages
	if (isset($_SESSION['msg'])) {
		$msg = $_SESSION['msg'];
		if(substr($msg, 0, 3) == 'err') {
			$message = '<div class="msg err">'. $lang['msg'][$msg] .'</div>';
		} else {
			$message = '<div class="msg ok">'. $lang['msg'][$msg] .'</div>';
		}
	}

	if (isset($_SESSION['upl'])) {
		$message = '<div>'. $lang['msg']['upl'] .'</div>';
		$message = str_replace('%url%', './'.UPL_DIR.'/'.$_SESSION['upl'], $message);
	}

	echo $message;
}

//						\\

function handle_upload ()
{
	if(isset($_GET['do']) AND $_GET['do'] == 'upl') {
		global $forb_ext;

		$name = secure_the_filename($_FILES['userfile']['name'],FILENAME_MAXLEN);

		$ext = get_ext($name);
		if(in_array($ext, $forb_ext)){
			$name = $name.'.txt';
		}

		$target_dir = $_POST['target_dir'];
		$target_dir = secure_path($target_dir);

		if($target_dir !== ''	AND	$target_dir != '/') {
			$_SESSION['remember_dir'] = $target_dir;
			$target_dir .= '/';
		} else {
			$_SESSION['remember_dir'] = '/';
			$target_dir = '';
		}

		if(!ALLOW_OW AND file_exists(DIR.'/'.UPL_DIR.'/'.$target_dir.$name)) {
			Msg('err_file_exists');
			Home();
		}

		if(is_uploaded_file($_FILES['userfile']['tmp_name'])) {
			move_uploaded_file($_FILES['userfile']['tmp_name'], DIR.'/'.UPL_DIR.'/'.$target_dir.$name);
			$_SESSION['upl'] = trim($target_dir.$name, '/'); // deleting slash from the beginning of string
			Home();
		}
	}
}

//						\\

function prepare_sorting ()
{

	@$sort = $_COOKIE['upl_sort'];
	if(!isset($sort)) {
		$sort = 'timeD';
	}

	// for table head
	($sort == 'name') ? $th_name = 'nameD' : $th_name = 'name';
	($sort == 'type') ? $th_type = 'typeD' : $th_type = 'type';
	($sort == 'size') ? $th_size = 'sizeD' : $th_size = 'size';
	($sort == 'time') ? $th_time = 'timeD' : $th_time = 'time';

	// preparing values for the sorting function (it needs column and DECS/ASC split into 2 parameters)
	if($sort[strlen($sort)-1] == 'D') {
		$ad = 'DESC';
		$sort = substr($sort, 0, strlen($sort)-1);
	} else {
		$ad = 'ASC';
	}

	if(in_array($sort, array('size', 'sizeD', 'time', 'timeD'))) {
		$comp = 'num';
	} else {
		$comp = 'str';
	}

	return array('func' => array($sort, $ad, $comp),
							 'table' => array('name' => $th_name, 'type' => $th_type, 'size' => $th_size, 'time' => $th_time));
}

//						\\

function whole_file_list ()
{
	global	$dir_list, $sort_par, $lang;

	$dir_list [] = '/';
	sort ($dir_list);
	// table head
	echo '<table id="mainTable"><thead><tr id="tableHead">
	<th id="th_name"><a href="?do=sort&amp;val='. $sort_par['table']['name'] .'">'. $lang['else']['th_name'] .'</a></th>
	<th id="th_type"><a href="?do=sort&amp;val='. $sort_par['table']['type'] .'">'. $lang['else']['th_type'] .'</a></th>
	<th id="th_size"><a href="?do=sort&amp;val='. $sort_par['table']['size'] .'">'. $lang['else']['th_size'] .'</a></th>
	<th id="th_time"><a href="?do=sort&amp;val='. $sort_par['table']['time'] .'">'. $lang['else']['th_time'] .'</a></th>
	<th id="th_del">'. $lang['else']['th_del'] .'</th></tr></thead>
	<tbody>';

	// explore every one directory in the dirlist

	echo_dir('/'); // recurs. function ;)
	echo '</tbody></table>';
}

//						\\

function get_file_list ($dir = '/')
{
	global $fn_hidden;
	$file_list = array();

	if($handle = opendir(UPL_DIR.$dir)) {
		$i = 0;
		while (false !== ($file = readdir($handle))) {
			$path = DIR.'/'.UPL_DIR.$dir.$file;

			if (!in_array($file, $fn_hidden) AND !is_dir($path)) {
				$file_list[$i]['dir'] = $dir;
				$file_list[$i]['name'] = $file;
				$file_list[$i]['size'] = fileSize($path);
				$file_list[$i]['type'] = get_ext($file);
				$file_list[$i]['time'] = fileCTime($path);
				$file_list[$i]['time_easy'] = date('j.n.', $file_list[$i]['time']);
				$file_list[$i]['time_complete'] = date('j.n.Y - G:i', $file_list[$i]['time']);
				$i++;
			}
		}
		closedir($handle);
	}
	return $file_list;
}

//						\\

function echo_dir($dir)
{
	global $dir_list, $lang, $sort_par;

	// indent building
	if ($dir == '/')	$level = 0;
		else	$level = substr_count($dir, '/');
	$indent = '';
	for ($i=0;$i<$level;$i++) $indent .= INDENT;

	// echo folder name (== table head)
	echo_table_head($dir, $indent);

	// first handle the subdirs...
	$subdirs = get_direct_subdirs($dir);
	$subdirs_count = count($subdirs);
	if(count($subdirs)){
		for($i=0;$i<$subdirs_count;$i++){
			echo_dir($subdirs[$i]);
		}
	}

	// ...then echo current folder's filelist
	if($dir == '/')	$dir = ''; // because of root
	$file_list = get_file_list($dir.'/');
	if (count($file_list)) {
		echo_file_list(sortmddata($file_list, $sort_par['func'][0],$sort_par['func'][1], $sort_par['func'][2]), $indent);
	} else {
		echo '<tr class="emptyDir"><td class="name">'. $indent . $lang['else']['empty_dir'] .'</td>
		<td class="type">&nbsp;</td>
		<td class="size">&nbsp;</td>
		<td class="time">&nbsp;</td>
		<td class="del">&nbsp;</td></tr>'.NL;
	}

	echo_table_foot();
}

//						\\

function get_direct_subdirs($dir)
{
	global $dir_list;

	if($dir == '/') $dir = '';
	$dir_length = strlen($dir);
	$slashes_count = substr_count($dir, '/');
	$dir_list_count = count($dir_list);

	$subdirs = array();
	for($i=0;$i<$dir_list_count;$i++){
		// if there is +1 slash AND ...
		if(($slashes_count + 1 == substr_count($dir_list[$i], '/'))	AND	($dir.'/' == substr($dir_list[$i], 0, $dir_length+1)) AND ($dir_list[$i] !== '/')) {
			$subdirs[] = $dir_list[$i];
		}
	}

	return $subdirs; // its array
}

//						\\

function echo_table_head($dir, $indent)
{
	global $design, $lang;

	if($dir == '/') {
		$dir_save_name = 'root';
		$dir_show_name = '/';
	}
	else {
		$dir_save_name = trim($dir, '/');
		$dir_show_name = array_pop(explode('/',$dir_save_name));
		$dir_save_name = str_replace('/', '_', $dir_save_name);
	}

	// delete link
		if (ALLOW_DEL AND $dir != '/') {
			$del = '<a href="?do=del_dir&amp;val='.$dir.'" onclick="return deleteDialog(\''.$dir.'\');" title="'.$lang['else']['del_file_title'].'">'.$lang['else']['del_file_link'].'</a>';
		} else {
			$del = '&nbsp;';
		}

	echo NL.'<tr><td colspan="5">
	<table><thead><tr class="dir"><td class="name" onclick="DoIt(\''.$dir_save_name.'\');">'. $indent .'<strong><span>'.$dir_show_name.'</span></strong></td>
	<td class="type">&nbsp;</td>
	<td class="size">&nbsp;</td>
	<td class="time">&nbsp;</td>
	<td class="del">'.$del.'</td></tr></thead>
	<tbody id="'.$dir_save_name.'">'.NL;
}

//						\\

function echo_table_foot()
{
	echo '</tbody></table></td></tr>'.NL;
}

//						\\

function echo_file_list($file_list, $indent)
{
	global	$ft_archive, $ft_music, $ft_image, $ft_video, $lang, $file_count_all, $size_of_all;

	$file_count = count($file_list);
	for ($i = 0; $i < $file_count; $i++) {
		extract($file_list[$i]);

		$file_count_all++;
		$size_of_all += $size;

		if		 (in_array($type, $ft_archive)) $ft_style = ' archive';
		elseif (in_array($type, $ft_image))	 $ft_style = ' image';
		elseif (in_array($type, $ft_music))	 $ft_style = ' music';
		elseif (in_array($type, $ft_video))	 $ft_style = ' video';

		if ($size > 10)
			$size = format_file_size($size);

		if ($dir == '/') $dir = ''; // just must be :)
		if (trim($dir.$name, '/') == $_SESSION['upl']) {
			$classnew = ' new';
		} else {
			$classnew = '';
		}
		if ($dir == '') $dir = '/';

		// delete link
		if (ALLOW_DEL) {
			$del = '<a href="?do=del_file&amp;val='.$dir.$name.'" onclick="return deleteDialog(\''.$name.'\');" title="'.$lang['else']['del_file_title'].'">'.$lang['else']['del_file_link'].'</a>';
		}

		echo '<tr class="file'.$classnew.'"><td class="name">'.$indent.'<a href="./'.UPL_DIR.$dir.$name.'">'.$name.'</a></td>
		<td class="type'.$ft_style.'">'.$type.'</td>
		<td class="size">'.$size.'</td>
		<td class="time">'.$time_easy.'</td>
		<td class="del">'.$del.'</td></tr>'.NL;
	}
}

//						\\

function echo_login_form()
{
	global $lang;
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
 <meta http-equiv="content-type" content="text/html; charset=utf-8">
 <title><?php echo $lang['log']['title']; ?></title>
</head>
<body onload="document.forms[0].pass.focus();">
	<h1><?php echo $lang['log']['heading']; ?></h1>
	<p><?php echo $lang['log']['text_before']; ?></p>
	<form action="?do=login" method="post" style="margin:1em;">
		<div><input type="password" name="pass"> <input type="submit" value="<?php echo $lang['log']['button_login']; ?>"></div>
	</form>
	<p><?php echo $lang['log']['text_before']; ?></p>
</body></html>
<?php
}

//						\\

function handle_login()
{
	if(isset($_POST['pass'])) {

		$pass = $_POST['pass'];
		$pass_hashed = md5($pass);

		if(PASSWORD_HASHED) {
			$pass = $pass_hashed;
		}

		if($pass == PASSWORD) {
			$_SESSION['logged'] = $pass_hashed;
			Home();
		}
	}
}

//						\\

function define_logged()
{
	if(NEED_PASSWORD) {
		if(!isset($_SESSION['logged'])) {
			define('LOGGED', false);
		} else {

			// check session <-> setting
			if(!PASSWORD_HASHED) {
				$pass_sett = md5(PASSWORD);
			} else {
				$pass_sett = PASSWORD;
			}

			if($_SESSION['logged'] == $pass_sett) {
				define('LOGGED', true);
			} else {
				define('LOGGED', false);
			}

		}
	} else {
		define('LOGGED', true);
	}
}

//						\\

function handle_logout()
{
	if(isset($_GET['do']) AND $_GET['do'] == 'logout') {
		$_SESSION['logged'] = NULL;
		Home();
	}
}

//						\\

function handle_delete()
{
	if(isset($_GET['do'])) {

		$do	= $_GET['do'];
		$val = secure_path($_GET['val']);
	
		// files
		if($do == 'del_file' AND isset($val) AND ALLOW_DEL) {
			if(unlink(UPL_DIR.$val)) {
				Msg('ok_file_deleted');
				Home();
			} else {
				Msg('err_file_not_deleted');
				Home();
			}
		}
	
		// dirs
		if($do == 'del_dir' AND isset($val) AND $val != '/' AND ALLOW_DEL) {
			if(@rmdir(UPL_DIR.$val)) {
				Msg('ok_dir_deleted');
				Home();
			} else {
				Msg('err_dir_not_deleted');
				Home();
			}
		}
	}
}

//						\\

function echo_size_of_all()
{
	global $size_of_all;
	echo format_file_size($size_of_all);
}

//						\\

function check_free_space()
{
	if(MAX_SPACE == 0) {
		define('CAN_UPLOAD', 1);
	} else {
		global $max_space, $free_space; // for stats
		$max_space = MAX_SPACE * 1024 * 1024; // in bytes
		$filled_space = dirSize(UPL_DIR);

		$free_space = $max_space - $filled_space;

		if($free_space > 0) {
			define('CAN_UPLOAD', 1);
		} else {
			define('CAN_UPLOAD', 0);
		}

		$free_space = format_file_size($free_space);
		$max_space	= format_file_size($max_space);
	}
}

//						\\

function secure_path($path)
{
	$path = str_replace('..','',$path);
	while ($path[0] == '.') {
		$path = substr($path,1);
	}
	return $path;
}

//						\\



//						\\



/*	 function SortMDData
 *	 written by a unknown good man
 *	 http://cz.php.net/manual/cs/function.array-multisort.php#61334
*/
function sortmddata ($array, $by, $order, $type)
{
	$sortby = "sort$by";
	$firstval = current($array);
	$vals = array_keys($firstval);
	foreach ($vals as $init){
		$keyname = "sort$init";
		$$keyname = array();
	}

	foreach ($array as $key => $row) {
		foreach ($vals as $names){
			$keyname = "sort$names";
			$test = array();
			$test[$key] = $row[$names];
			$$keyname = array_merge($$keyname,$test);
		}
	}

	if ($order == "DESC"){
		if ($type == "num"){
			array_multisort($$sortby,SORT_DESC, SORT_NUMERIC,$array);
		} else {
			array_multisort($$sortby,SORT_DESC, SORT_STRING,$array);
		}
	} else {
		if ($type == "num"){
			array_multisort($$sortby,SORT_ASC, SORT_NUMERIC,$array);
		} else {
			array_multisort($$sortby,SORT_ASC, SORT_STRING,$array);
		}
	}
	return $array;
}

/*	 class Timer
 *	 written by Miroslav Navrátil aka Tark
 *	 http://continuer.nfo.sk/
*/

class Timer {
	var $start;
	var $end;

	function getmicrotime() {
		list($usec, $sec) = explode(" ",microtime());
		return ((float)$usec + (float)$sec);
	}

	function start() {
		$this->start = $this->getmicrotime();
	}

	function stop() {
		$this->end = $this->getmicrotime();
	}

	function returntime() {
		$time = $this->end - $this->start;
		$time = round($time, 3);
		return $time;
	}
}

/*	 function DirSize
 *	 written by Aidan Lister
 *	 http://aidanlister.com/repos/v/function.dirsize.php
*/

function dirsize($directory)
{
	// Init
	$size = 0;
	// Trailing slash
	if (substr($directory, -1, 1) !== DIRECTORY_SEPARATOR) {
			$directory .= DIRECTORY_SEPARATOR;
	}
	// Create the stack array
	$stack = array($directory);
	// Iterate stack
	for ($i = 0, $j = count($stack); $i < $j; ++$i) {
		// Add to total size
		if (is_file($stack[$i])) {
			$size += filesize($stack[$i]);
		}
		// Add to stack
		elseif (is_dir($stack[$i])) {
			// Read directory
			$dir = dir($stack[$i]);
			while (false !== ($entry = $dir->read())) {
				// No pointers
				if ($entry == '.' || $entry == '..') {
					continue;
				}
				// Add to stack
				$add = $stack[$i] . $entry;
				if (is_dir($stack[$i] . $entry)) {
					$add .= DIRECTORY_SEPARATOR;
				}
				$stack[] = $add;
			}
			// Clean up
			$dir->close();
		}
		// Recount stack
		$j = count($stack);
	}
	return $size;
}
?>
